Last Comment Bug 784227 - (gonk-jb) JB Gonk Support (Android 4.3)
(gonk-jb)
: JB Gonk Support (Android 4.3)
Status: RESOLVED FIXED
: meta
Product: Firefox OS
Classification: Client Software
Component: General (show other bugs)
: unspecified
: All Gonk (Firefox OS)
: -- normal (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
:
Mentors:
: 779548 (view as bug list)
Depends on: 694484 784226 788975 867871 868065 868124 868150 869206 869251 869260 870198 870682 870684 871364 874116 874649 877191 878108 879428 880095 880502 881565 883945 884131 884134 884239 885602 885620 885809 887485 887620 887627 888552 890144 890541 891261 892182 892876 894538 894683 895665 896765 898506 898810 898812 898897 898898 899377 899769 901857 902044 902255 902273 902319 902769 902865 902954 904484 906577 906590 906888 908044 911271 911294 911391 911518 911548 914190
Blocks: 784415 842747 koi-devices ASLR-b2g 845193 860628 885630 HWComposer 902797 903308
  Show dependency treegraph
 
Reported: 2012-08-20 18:09 PDT by Michael Wu [:mwu]
Modified: 2014-08-04 19:31 PDT (History)
65 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
-


Attachments
nexus 4 manifest (9.53 KB, text/xml)
2013-05-02 17:46 PDT, Michael Wu [:mwu]
no flags Details
nexus 4 manifest, v2 (9.47 KB, patch)
2013-05-20 12:55 PDT, Michael Wu [:mwu]
no flags Details | Diff | Splinter Review

Description Michael Wu [:mwu] 2012-08-20 18:09:41 PDT
This is a tracking bug for things necessary on the gecko side to support JB based Gonk.
Comment 1 Michael Wu [:mwu] 2012-11-28 13:37:05 PST
Since Android 4.2 is also Jelly Bean, I'm morphing this bug to cover that particular jelly bean and skipping Android 4.1.
Comment 2 Guillaume Destuynder [:kang] (NEEDINFO to ensure replies) 2013-01-19 14:25:51 PST
*** Bug 779548 has been marked as a duplicate of this bug. ***
Comment 3 Chris Jones [:cjones] inactive; ni?/f?/r? if you need me 2013-02-25 22:12:52 PST
My understanding is that the bluetooth stack was rewritten in JB.  Do we have any idea of the work needed to "rebase" (sigh) on that?
Comment 4 Vicamo Yang [:vicamo][:vyang] 2013-02-26 03:29:17 PST
I had merged RIL related code in hardware/ril[1] and external/emulator[2]. Still have build breaks with ICS Gonk, of course.

[1]: https://github.com/mozilla-b2g/platform_hardware_ril/tree/next/jb-mr1-release
[2]: https://github.com/mozilla-b2g/platform_external_qemu/tree/next/jb-mr1-release
Comment 5 Kyle Machulis [:kmachulis] [:qdot] 2013-03-08 11:03:39 PST
(In reply to Chris Jones [:cjones] [:warhammer] from comment #3)
> My understanding is that the bluetooth stack was rewritten in JB.  Do we
> have any idea of the work needed to "rebase" (sigh) on that?

Well, the Bluetooth Platform Portion is abstracted so that we /should/ just be able to implement a new BluetoothService subclass filled in with the new calls, and be on our way. That said, it was modeled after the DBus setup because I haven't seen anything else so that was my only experience to build off of. So it's going to depend on how well those two mesh, and how much needs to be changed to support them. I have yet to actually see the new stack (I think echou has, but I'm not gonna say for sure.), so I can't really say anything beyond that.

The DBus layer will still be valid for linux, though we need to implement a few more linux service functions to make it have complete feature pairity with android.
Comment 6 Shawn Huang [:shawnjohnjr] 2013-03-11 03:44:05 PDT
The new JB bluedroid stack is quite different from bluez. Dbus layer completely was removed, even no more bluetooth daemon. I believe the change could be big if we adapt bluedroid stack. Since currently we have design dependency on BlueZ dbus.
Comment 7 Marco Chen [:mchen] 2013-03-15 02:16:36 PDT
1. Also JB starts to support volume control on each output devices. That means we need to change the API in AudioManager and settings data in Gaia side also the UX.

2. Power API for set_screen_state is changed to autosuspend_enable/disable.

3. Wifi HAL API is changed too.

4. The API changes of AudioTrack can be covered by backend of cubeb + openSL ES.
Comment 8 Vincent Liu[:vliu] 2013-03-15 02:49:19 PDT
Some wifi functions in libhardware_legacy got different argument list. There must have some changes in HAL and its above leyer.
Comment 9 Sotaro Ikeda [:sotaro] 2013-03-15 06:35:19 PDT
ISurfaceTexture is changed in JB. It is used in GonkNativeWindow since v1.1 by Bug 803471.
Comment 10 Vladimir Vukicevic [:vlad] [:vladv] 2013-03-15 08:56:27 PDT
I thought I posted this here; I have some patches for JB support on m-c at https://github.com/vvuk/mozilla-central/tree/b2g-jb with some more info at https://wiki.mozilla.org/B2G/Nexus7.  I haven't touched this in a few weeks though, but it might be a useful start (it built and ran on a N7 at the time).
Comment 11 Michael Wu [:mwu] 2013-05-02 17:46:28 PDT
Created attachment 744936 [details]
nexus 4 manifest

Here's a nexus 4 manifest to try.

The line saying "include external/junit/Common.mk" in frameworks/base/Android.mk needs to be commented out.
Permissions in /system/b2g have to be fixed manually.

Lots of issues still, and a bit crashy.

The device name is "mako".
Comment 12 Randy Lin [:rlin] - Be Mozillian on 2015/01/26 2013-05-10 00:22:50 PDT
Hi Michael, 
Do we want gecko to support both ICS and JB on the same version, 
That means we would likely to use build flag to distinguish the API change?
Comment 13 James Zhang (Spreadtrum) 2013-05-10 02:16:55 PDT
Hi Michael,

   We‘re porting FFOS to JB, but camera can't work now. Do you have any schedule to support camera on JB?
Comment 14 Michael Wu [:mwu] 2013-05-10 15:13:13 PDT
(In reply to Randy Lin [:rlin] from comment #12)
> Hi Michael, 
> Do we want gecko to support both ICS and JB on the same version, 
> That means we would likely to use build flag to distinguish the API change?

Bug 868150 allows us to distinguish between ICS and JB at compile time. We'll need gecko to support both ICS and JB for the time being.
Comment 15 Michael Wu [:mwu] 2013-05-10 15:34:46 PDT
(In reply to James Zhang from comment #13)
> Hi Michael,
> 
>    We‘re porting FFOS to JB, but camera can't work now. Do you have any
> schedule to support camera on JB?

There might be an engineer working on it next week, but I can't comment on any schedule.
Comment 16 Sotaro Ikeda [:sotaro] 2013-05-13 11:41:25 PDT
> >    We‘re porting FFOS to JB, but camera can't work now. Do you have any
> > schedule to support camera on JB?
> 
> There might be an engineer working on it next week, but I can't comment on
> any schedule.

Last week, I receive nexus4 and flashed JB on it. From this week, I am going to work on it. But I can not comment when camera works.
Comment 17 Michael Wu [:mwu] 2013-05-20 12:55:44 PDT
Created attachment 751805 [details] [diff] [review]
nexus 4 manifest, v2

This manifest switches to upstream versions of everything where there is support. There's only two repos left that are on my github account. Gecko is now pointed to upstream, so we can work off the latest mozilla-central.
Comment 18 Michael Wu [:mwu] 2013-05-23 17:21:15 PDT
The manifest is now available from the b2g-manifest repo - https://github.com/mozilla-b2g/b2g-manifest/blob/master/nexus-4.xml .
Comment 19 Sandip Kamat 2013-07-08 18:02:08 PDT
Recommending this for koi+ (JB support for v1.2)
Comment 20 Sotaro Ikeda [:sotaro] 2013-07-24 15:35:23 PDT
Are we going to use JB4.2 as gonk-jb? Today, JB4.3 is released on already open sourced. There are some differences around Graphics and DisplayHardware.
Comment 21 Michael Wu [:mwu] 2013-07-24 15:43:13 PDT
(In reply to Sotaro Ikeda [:sotaro] from comment #20)
> Are we going to use JB4.2 as gonk-jb? Today, JB4.3 is released on already
> open sourced. There are some differences around Graphics and DisplayHardware.

Sounds good. I think we're currently still early enough in 1.2 to switch to 4.3.
Comment 22 Sotaro Ikeda [:sotaro] 2013-07-24 15:54:08 PDT
JB4.3 support OpenGL ES3.0. By using it, we can implement WebGL2 on Firefox OS.
 - https://wiki.mozilla.org/Platform/GFX/WebGL2
Comment 23 Michael Vines [:m1] [:evilmachines] 2013-07-24 16:41:58 PDT
We'll use 4.3
Comment 24 Sotaro Ikeda [:sotaro] 2013-07-24 17:11:12 PDT
In 4.3, camera is extended a lot, ProCamera is present. Need to support it.
Comment 25 James Zhang (Spreadtrum) 2013-07-25 17:40:01 PDT
I think 4.3 is better than 4.2 for us.
Comment 26 Michael Wu [:mwu] 2013-07-27 21:30:46 PDT
4.3 it is.
Comment 27 andy.liu 2013-07-28 20:09:11 PDT
(In reply to Michael Wu [:mwu] from comment #26)
> 4.3 it is.

Hello,Michael,I have a question.Is update to android4.3 a new official decison or just engineer talk now? Thanks.
Comment 28 Michael Wu [:mwu] 2013-07-28 22:02:44 PDT
(In reply to andy.liu from comment #27)
> (In reply to Michael Wu [:mwu] from comment #26)
> > 4.3 it is.
> 
> Hello,Michael,I have a question.Is update to android4.3 a new official
> decison or just engineer talk now? Thanks.

We will support 4.3. I've filed four new bugs with patches that add support for 4.3. Will 4.3 be ok for you?
Comment 29 andy.liu 2013-07-28 22:12:43 PDT
(In reply to Michael Wu [:mwu] from comment #28)
> (In reply to andy.liu from comment #27)
> (In reply to Michael Wu [:mwu]
> from comment #26)
> > 4.3 it is.
> 
> Hello,Michael,I have a question.Is
> update to android4.3 a new official
> decison or just engineer talk now?
> Thanks.

We will support 4.3. I've filed four new bugs with patches that add
> support for 4.3. Will 4.3 be ok for you?
Yes,android4.3 is perfect for as.But dose it mean Mozilla v1.2 will support android4.3 directly?And android4.2 will be deserted right now?
what about the new schedule for supporting android4.3? Will it be ready at 16th Sept.?
Thanks.
Comment 30 Michael Wu [:mwu] 2013-07-28 22:29:58 PDT
The patches I posted brings our 4.3 port to the same level that the 4.2 port is currently at. The only thing remaining 4.3 upgrade risk is for camera support. JB camera support hasn't landed, so I haven't tried upgrading it from 4.2 to 4.3.
Comment 31 andy.liu 2013-07-28 23:25:50 PDT
(In reply to Michael Wu [:mwu] from comment #30)
> The patches I posted brings our 4.3 port to the same level that the 4.2 port
> is currently at. The only thing remaining 4.3 upgrade risk is for camera
> support. JB camera support hasn't landed, so I haven't tried upgrading it
> from 4.2 to 4.3.

Ok, thanks for your reply.We hope that android 4.3 is supported ASAP.
BTW,in my mind ,independent of android version upgrade  is a better choice for ffos long-term roadmap.
Comment 32 Michael Wu [:mwu] 2013-07-30 18:49:09 PDT
All necessary 4.3 patches have been landed.
Comment 33 Joe Cheng [:jcheng] 2013-08-28 04:03:16 PDT
koi+ as it is targeted for v1.2
Comment 34 Preeti Raghunath(:Preeti) 2013-09-18 15:15:17 PDT
Meta bug - hence minus
Comment 35 James Zhang (Spreadtrum) 2013-11-03 03:25:06 PST
What about kitkat(android4.4)? 
I think it's better for low memory device.
Comment 36 Michael Wu [:mwu] 2013-11-03 05:33:08 PST
(In reply to James Zhang from comment #35)
> What about kitkat(android4.4)? 
> I think it's better for low memory device.

A new bug will be filed for android 4.4. A nexus 5 is being shipped to me at the moment so I'll be able to take a look at it in a few days.
Comment 37 Michael Wu [:mwu] 2013-11-12 12:48:20 PST
Marking as fixed as I believe we have feature parity with the ICS port now. Bluedroid work continues to be tracked in bug 876583.

I'll post here when there is more news about kitkat support.
Comment 38 Asa Dotzler [:asa] 2013-11-13 14:04:10 PST
https://developer.mozilla.org/en-US/docs/Mozilla/Firefox_OS/Firefox_OS_build_prerequisites#Requirements_for_Mac_OS_X has a note that suggests the doc needs updating once this is available. Is that now?
Comment 39 Michael Wu [:mwu] 2013-11-13 14:10:13 PST
That has nothing to do with this bug. Also, it is wrong.
Comment 40 Michael Wu [:mwu] 2013-12-13 14:31:56 PST
FYI, kitkat porting is being tracked in bug 943278 .

Note You need to log in before you can comment on or make changes to this bug.